
%%%% This script has been used to detect the received phase modulated
%%%% signals. It has been modified many times depending on which signals
%%%% that are being detected, so it is just an example. 


clear
clc


format long

% open the figure again
fighandle=openfig('test1source.fig');
ax=findall(fighandle,'Type','line');
x1=get(ax,'Xdata');
y1=get(ax,'YData');
yy1=y1(1:512);

% open the figure again
fighandle=openfig('test11mottaker1000m.fig');
ax=findall(fighandle,'Type','line');
x2=get(ax,'Xdata');
y2=get(ax,'YData');
yy2=y2(1:512).*1e4;

% open the figure again
fighandle=openfig('test1mottaker1000m.fig');
ax=findall(fighandle,'Type','line');
kx2=get(ax,'Xdata');
ky2=get(ax,'YData');
kyy2=ky2(1:512).*1e4;



% % open the figure again
% fighandle=openfig('malmottaker3000m.fig');
% ax=findall(fighandle,'Type','line');
% x3=get(ax,'Xdata');
% y3=get(ax,'YData');
% yy3=y3(1:512);

f_s=800;
N=512;

del_t=1/f_s;
n=1:N;

t=n*del_t;

TT=max(t);
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Sender

resI1 = zeros(4,512);
resQ1 = zeros(4,512);
I = zeros(10,4);
Q = zeros(10,4);
bp = zeros(10,4);



% for nn=1:1:4
% hold on    
%     
% pp=cos(2.*pi.*35e3.*(t)+((2*nn-1).*pi)/4);
% 
% resI1(nn,:) = yy1.*(2/TT).*pp.*cos(2.*pi.*35e3.*(t));
% resQ1(nn,:) = yy1.*(2/TT).*pp.*sin(2.*pi.*35e3.*(t));
% 
% I(1,nn)=trapz(t,resI1(nn,:));
% Q(1,nn)=trapz(t,resQ1(nn,:));
% 
% bp(1,nn) = I(1,nn) - 1i.*Q(1,nn);
% 
% figure(4);
% plot(real(bp(1,nn)),imag(bp(1,nn)),'x','Linewidth',1,'Linestyle','none');
% 
% 
% end
% grid on
% plot([-6 6], [0 0],'k', 'Linewidth',2)
% plot([0 0], [-6 6],'k', 'Linewidth',2)
% title('Detected message points')
% xlabel('X1')
% ylabel('X2')
% 
% hold off



% resI2 = zeros(4,512);
% resQ2 = zeros(4,512);
% 
% 
% for nn=1:1:4
% hold on    
%     
% pp=cos(2.*pi.*35e3.*(t)+((2*nn-1).*pi)/4);
% 
% resI2(nn,:) = yy2.*(2/TT).*pp.*cos(2.*pi.*35e3.*(t));
% resQ2(nn,:) = yy2.*(2/TT).*pp.*sin(2.*pi.*35e3.*(t));
% 
% I(2,nn)=trapz(t,resI2(nn,:));
% Q(2,nn)=trapz(t,resQ2(nn,:));
% 
% bp(2,nn) = I(2,nn) - 1i.*Q(2,nn);
% 
% figure(5);
% plot(real(bp(2,nn)),imag(bp(2,nn)),'x','Linewidth',1,'Linestyle','none');
% 
% 
% end
% grid on
% plot([-60 60], [0 0],'k', 'Linewidth',2)
% plot([0 0], [-60 60],'k', 'Linewidth',2)
% title('Detected message points')
% xlabel('X1')
% ylabel('X2')
% 
% hold off



resI3 = zeros(4,512);
resQ3 = zeros(4,512);
noi = 0.2;
%%%% Detection of message points.
% for ww=1:1:5
% 
% resI3 = zeros(4,512);
% resQ3 = zeros(4,512);
% I = zeros(10,4);
% Q = zeros(10,4);
% bp = zeros(10,4);
% 
%     for nn=1:1:4
%     hold on    
%     nnn = noi.*std(kyy2).*randn(1,512);
%     yy3 = yy2 + nnn;
%     pp=cos(2.*pi.*35e3.*(t)+((2*nn-1).*pi)/4);
% 
%     resI3(nn,:) = yy3.*(2/TT).*pp.*cos(2.*pi.*35e3.*(t));
%     resQ3(nn,:) = yy3.*(2/TT).*pp.*sin(2.*pi.*35e3.*(t));
% 
%     I(3,nn)=trapz(t,resI3(nn,:));
%     Q(3,nn)=trapz(t,resQ3(nn,:));
% 
%     bp(3,nn) = I(3,nn) - 1i.*Q(3,nn);
% 
%     figure(6);
%     plot(real(bp(3,nn)),imag(bp(3,nn)),'x','Linewidth',1,'Linestyle','none');
% 
%     
%     end
%     
% grid on
% 
% 
% end
% 
% plot([-120 120], [0 0],'k', 'Linewidth',2)
% plot([0 0], [-120 120],'k', 'Linewidth',2)
% title('Detected message points')
% xlabel('X1')
% ylabel('X2')
% 
% hold off
% 
% figure(10);
% plot(t,yy2);
% 
% figure(11);
% plot(t,yy3);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% %%% SNR
% Psig = (1/length(yy3)).*sum(yy3.^2)
% Pnoise = (1/length(nnn)).*sum(nnn.^2)
% 
% SNR = 10.*log10(Psig/Pnoise)

% %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%% SYMBOL ERROR

iterasjoner=50000;

resI4 = zeros(4,512);
resQ4 = zeros(4,512);
resI5 = zeros(4,512);
resQ5 = zeros(4,512);
I4 = zeros(10,4);
Q4 = zeros(10,4);
I5 = zeros(10,4);
Q5 = zeros(10,4);
bp4 = zeros(100,4);
bp5 = zeros(100,4);
kvadrant = 0;
kvadrant2 = 0;
errotteller = 0;

for ww=1:1:iterasjoner


    for nn=1:1:4
%     
%     
%     nnn = 0.5.*std(yy2).*randn(1,512);
 nnn = noi.*std(kyy2).*randn(1,512);
    yy4 = yy2 + nnn;

%     yy4 = yy2 + nnn;
    pp=cos(2.*pi.*35e3.*(t)+((2*nn-1).*pi)/4);

    resI4(nn,:) = yy2.*(2/TT).*pp.*cos(2.*pi.*35e3.*(t));
    resQ4(nn,:) = yy2.*(2/TT).*pp.*sin(2.*pi.*35e3.*(t));
    resI5(nn,:) = yy4.*(2/TT).*pp.*cos(2.*pi.*35e3.*(t));
    resQ5(nn,:) = yy4.*(2/TT).*pp.*sin(2.*pi.*35e3.*(t));
    
    I4(3,nn)=trapz(t,resI4(nn,:));
    Q4(3,nn)=trapz(t,resQ4(nn,:));
    I5(3,nn)=trapz(t,resI5(nn,:));
    Q5(3,nn)=trapz(t,resQ5(nn,:));

    bp4(ww,nn) = I4(3,nn) - 1i.*Q4(3,nn);  
    bp5(ww,nn) = I5(3,nn) - 1i.*Q5(3,nn);  
    
    if real(bp4(ww,nn))>=0 && imag(bp4(ww,nn))>=0
        kvadrant = 1;
    elseif real(bp4(ww,nn))<=0 && imag(bp4(ww,nn))>=0
        kvadrant = 2;
    elseif real(bp4(ww,nn))<=0 && imag(bp4(ww,nn))<=0
        kvadrant = 3;
    else 
        kvadrant = 4;
    end
    
    if real(bp5(ww,nn))>=0 && imag(bp5(ww,nn))>=0
        kvadrant2 = 1;
        % plot(real(bp5(3,nn)),imag(bp(3,nn)),'x','Linewidth',2,'Linestyle','none');
    elseif real(bp5(ww,nn))<=0 && imag(bp5(ww,nn))>=0
        kvadrant2 = 2;
        % plot(real(bp5(3,nn)),imag(bp(3,nn)),'x','Linewidth',2,'Linestyle','none');
    elseif real(bp5(ww,nn))<=0 && imag(bp5(ww,nn))<=0
        kvadrant2 = 3;
        % plot(real(bp(53,nn)),imag(bp5(3,nn)),'x','Linewidth',2,'Linestyle','none');
    else 
        kvadrant2 = 4;
         %plot(real(bp5(3,nn)),imag(bp5(3,nn)),'x','Linewidth',2,'Linestyle','none');
    end
    
    if kvadrant~=kvadrant2
    errotteller=errotteller+1;
    end
    
     
   
    
    end
    
    
end

%%%% SNR
Psig = (1/length(yy4)).*sum(yy4.^2);
Pnoise = (1/length(nnn)).*sum(nnn.^2);

SNR = 10.*log10(Psig/Pnoise)




errotteller

BER = (errotteller/(4.*iterasjoner))/2


